adinstbpm - Task #19608
Milestone # 20350 (New): IOTA BPM deployment
Milestone # 19607 (New): IOTA ACNET Interface
Crate status and control device
04/09/2018 02:32 PM - John Diamond

Status: Work in progress Start date: 04/09/2018
Priority: Normal Due date:

Assignee: Elliott McCrory % Done: 80%
Category: Estimated time: 24.00 hours
Target version: Spent time: 22.00 hours
Description

This device will give status about the crate hardware and the status of bpmd.

History

#1 - 04/09/2018 02:57 PM - John Diamond

Recommended device naming pattern: x:BPMyyy
e yyy = three digit crate identifier
Reading property:

¢ Structured data with 4 byte elements unsigned integers
o [0] = bpmd uptime counter (number of seconds)
o [1] = bpmd pid
o [2] = number of DAQ modules present
o [3] = integer representation of the DAQ state
o [4] = number of BPMs configured
o [5] = integer representation of the state machine type
o [6] = state machine cycle counter
o [7] = most recent state machine cycle identifier

Setting property:
* none
Status property:

Bit 0: bpmd is running

Bit 1: Timing signal generator is present
Bit 2: Clock decoder is present

Bit 3: DAQ modules are ready

Bit 4: DAQ modules are armed

Bit 5: DAQ modules are triggered

Bit 6: State machine is enabled

Bits 19-31: DAQ module present in slot n

Control property:

: start bpmd

: shutdown bpmd

: restart bpmd

: enable state machine
: disable state machine
#2 - 04/09/2018 03:06 PM - John Diamond
- Estimated time set to 24.00 h
- Parent task set to #19607

#3 - 04/09/2018 03:24 PM - John Diamond
- Status changed from New to Assigned

- Assignee set to Elliott McCrory
#4 - 04/10/2018 08:22 AM - John Diamond

Link to AD/Controls documentation for developing Linux ACNET front ends.

#5 - 04/17/2018 01:38 PM - John Diamond
To clarify:
e [5] = integer representation of the state machine type
o Use MachineContext::machineGet() and cast the FNALMachine to an unsigned int

¢ [7] = most recent state machine cycle identifier
o This is just my confusing way of saying the TCLK cycle reset ID. Use MachineContext::resetTCLKGet().

#6 - 10/17/2018 10:57 AM - Elliott McCrory
- Status changed from Assigned to Work in progress

- % Done changed from 0 to 80

There is an outstanding problem with setting some control bits at IOTA. However, we believe that this is not a problem in the front end. See logbook
entry: https://www-bd.fnal.gov/Elog/?orEntryld=141937
